*:*********************************************************************
*:
*:         System: TRANEDIT
*:         Author: Bill Kerr - 100014,3641
*:
*:		Based on an idea by Stphane Desnault
*:
*:  Procs & Fncts: REDRAW()
*:               : DRAWCURSOR()
*:               : MOUSEPRESS()
*:               : MOVERIGHT()
*:               : MOVELEFT()
*:               : MOVEDOWN()
*:               : MOVEUP()
*:               : SCREENHOME()
*:               : SCREENEND()
*:               : SCREENRIGHT()
*:               : SCREENLEFT()
*:               : SCREENUP()
*:               : SCREENDOWN()
*:               : EDITCELL()
*:               : QUESTION()
*:               : CLEARCURSOR()
*:               : DRAWELEV()
*:
*:          Calls: REDRAW()           (function  in AEDIT.PRG)
*:               : DRAWCURSOR()       (function  in AEDIT.PRG)
*:               : MOUSEPRESS()       (function  in AEDIT.PRG)
*:               : MOVERIGHT()        (function  in AEDIT.PRG)
*:               : MOVELEFT()         (function  in AEDIT.PRG)
*:               : MOVEDOWN()         (function  in AEDIT.PRG)
*:               : MOVEUP()           (function  in AEDIT.PRG)
*:               : SCREENHOME()       (function  in AEDIT.PRG)
*:               : SCREENEND()        (function  in AEDIT.PRG)
*:               : SCREENRIGHT()      (function  in AEDIT.PRG)
*:               : SCREENLEFT()       (function  in AEDIT.PRG)
*:               : SCREENUP()         (function  in AEDIT.PRG)
*:               : SCREENDOWN()       (function  in AEDIT.PRG)
*:               : EDITCELL()         (function  in AEDIT.PRG)
*:               : QUESTION()         (function  in AEDIT.PRG)
*:
*:*********************************************************************
PARAMETERS laArr, CtrlArr, lnVCnt, lnHCnt, Ctrl_Enq, WinLine, Win_Titl, Updte

* laArr     : Array being edited.
* CtrlArr	: Controlling 2-D Array.  Rows 1-6 should have a column for
*				each possible data column in laArr. Made up as follows:-
*			  Row 1	:	List of Headings for the columns
*			  Row 2	:	List of Picture clauses for input/output
*			  Row 3	:	List of prompts for each column
*			  Row 4	:	List of "WHEN" clauses to be evaluated
*			  Row 5	:	List of "DEFAULT" clauses to be evaluated
*			  Row 6	:	List of "VALID" clauses to be evaluated
*			  Row 7	:	Pre-Row Delete function
*			  Row 8	:	Post Row Delete function
*			  Row 9	:	Pre-Row Insert function
*			  Row 10:	Post Row Insert function

* lnVCnt    : -OPTIONAL- Number of lines of the array to display.
*             Defaults to the maximum number of lines that will fit
*             on the screen.
* lnHCnt    : Number of columns of the array to display.
* Ctrl_Enq	: Flag for enquiring on data only. .T. or .F.
*
* WinLine	: Line on screen to start displaying window.
*			  Defaults to centre of screen.
*
* Win_Titl	: Title of Transaction window
*
* Updte		: Allow Insert of lines or deleteion of lines? .F. = No

PRIVATE laLeftT		&& Array of line numbers down the side

PRIVATE lnTopRow    && Array index of the top-most displayed row.

PRIVATE lnLeftCol   && Array index of the left-most displayed row.

PRIVATE lnRow       && Current row of the cursor, relative to the 
                    && displayed rows (e.g. if the cursor is on the 
                    && top of the display, lnRow=1).

PRIVATE lnCol       && Current column of the cursor, relative to the 
                    && displayed columns (e.g. if the cursor is on 
                    && the left of the display, lnCol=1).
PRIVATE i,j         && i loops on rows, j loops on columns (generally).

PRIVATE lnLeftT     && Length of the titles on the left.

PRIVATE lnRowLen    && Total length of a displayed row

PRIVATE llExit      && Main event loop flag

PRIVATE lnHElev     && Position of the horizontal elevator.
                    && 0 indicates the leftmost position,
                    && WCOLS("editArray")-1 the rightmost one.
                    
PRIVATE lnVElev     && Position of the vertical elevator.
                    && 0 indicates the leftmost position,
                    && WCOLS("editArray")-1 the rightmost one.
                    
PRIVATE lcTalkStat  && Entry status of SET TALK
PRIVATE lcEscStat   && Entry status of SET ESCAPE
PRIVATE lcCurStat   && Entry status of SET CURSOR
PRIVATE lcBorder	&& Entry status of SET BORDER

PRIVATE lnKey       && Key code for the main event loop.

PRIVATE lcResult    && Returns Logical True if the array has changed.

PRIVATE RowLen		&& Length of one Row

PRIVATE lnRowSzs	&& Array of each column width + 1

PRIVATE lnRowAcum	&& Accumulated Row Sizes

PRIVATE LineFlg		&& Forces a whole Row to be entered

PRIVATE Arr_Row		&& Absolute Row in the Array

PRIVATE Col_Typs	&& Array of deduced column variable types

PRIVATE Arr_Ctrl	&& Control Flag for User Formulated Options (Functions)
					&& Set to :-	0 = Nothing to tell!
					&&				1 = Skipping Backwards at present

LineFlg = .F.
Ctrl_NewLne = .F.
lcResult=.F.
* Indexes into the passed controlling array *
Ctrl_Hdrs = 1
Ctrl_Pcts = 2
Ctrl_Pmpt = 3
Ctrl_Whnc = 4
Ctrl_Dflt = 5
Ctrl_Vald = 6
Ctrl_Prdl = 7
Ctrl_Psdl = 8
Ctrl_Prin = 9
Ctrl_Psin = 10
Arr_Ctrl = 0		&& User flag for stepping forwards
Arr_Row = 1

* Save the environment
lcBorder = SET("BORDER")
SET BORDER TO SINGLE

lcCompStat = SET("COMPATIBLE")
*SET COMPATIBLE FOXPLUS

lcTalkStat = SET("TALK")
SET TALK OFF

lcEscStat = SET("ESCAPE")
SET ESCAPE OFF

lcCurStat = SET("CURSOR")
SET CURSOR OFF

DIMENSION Col_Typs[ALEN(laArr,2)]
FOR j=1 TO ALEN(laArr,2)
  Col_Typs[j] = TYPE("laArr[1, j]")
ENDFOR (j)

DIMENSION Fkeys_Actions[10]
FOR i=1 TO 10
  Fkeys_Actions[i] = ON("KEY","F"+ALLTRIM(STR(i)))
ENDFOR (i)
PUSH KEY CLEAR

* Number of columns of the array to display
IF (TYPE("lnHCnt")<>"N") .OR. (lnHCnt>ALEN(laArr,2)) .OR. lnHcnt = 0
  lnHCnt=ALEN(laArr,2)
ENDIF

* Save a backup copy of the array we are editing
DIMENSION laBackup(ALEN(laArr,1),ALEN(laArr,2))
=ACOPY(laArr,laBackup)

* Initialize the title arrays if the user didn't pass them
* as parameters.

* Default line titles (1,2,3...)
DIMENSION laLeftT[ALEN(laArr,1),1]
= RowNos()

* Default column titles (A,B,..,Y,Z,AA,AB...)
IF EMPTY(CtrlArr[Ctrl_Hdrs,1])
  FOR j=1 TO ALEN(CtrlArr,2)
    CtrlArr[Ctrl_Hdrs,j]=IIF(j<=26,CHR(j+64),CHR(((j-1)/26)+64)+CHR(((j-1)%26)+65))
  ENDFOR
ENDIF

* Compute display parameters

* Determine Row Length
RowLen = 0
DIMENSION lnRowSzs[ALEN(CtrlArr,2)], lnRowAcum[ALEN(CtrlArr,2)]
FOR j=1 TO ALEN(CtrlArr,2)
	lnRowSzs[j]=LEN(TRANSFORM(1, CtrlArr[Ctrl_Pcts,j]))
	RowLen = RowLen + lnRowSzs[j] + 1
	lnRowAcum[j] = RowLen
ENDFOR (j)

* Width of the left title column
lnLeftT=0
FOR i=1 TO ALEN(laLeftT,1)
  lnLeftT=MAX(lnLeftT,LEN(laLeftT[i]))
ENDFOR

lnRowLen = lnLeftT + lnRowAcum[lnHcnt]
IF lnRowLen>(SCOLS()-4)
	WAIT WINDOW "The width of the passed parameters exceeds the screen width!"
	RETURN lcResult
ENDIF

* Number of lines of the array to display
IF (TYPE("lnVCnt")<>"N")
  lnVCnt=ALEN(laArr,1)
ENDIF

IF lnVCnt>(SROWS()-4)
  lnVCnt=(SROWS()-4)
ENDIF

* Define main editing window
Work = WinLine
IF TYPE("WinLine") <> "N" .OR. Work = 0
	Work = INT((SROW()-(lnVCnt+4))/2)
ENDIF
DEFINE WINDOW editArray ;
  FROM Work,INT((SCOL()-(lnRowLen+4))/2) ;
  TO Work+(lnVCnt+3), ;
  INT((SCOL()-(lnRowLen+4))/2)+(lnRowLen+3) ;
  FLOAT ;
  NOCLOSE ;
  NONE ;
  COLOR SCHEME 8

ACTIVATE WINDOW editarray

IF lnVCnt < ALEN(laArr,1) .AND. !WEXIST("wVElev")
  = Cre_Velv()						&& Create Vertical elevator
ENDIF

* Initialize display variables
lnTopRow=1
lnRow=1
lnLeftCol=1
lnCol=1
llExit=.F.
lnHElev=0
lnVElev=0

* Draw window borders
@         0,        0 FILL TO         0,WCOLS()-1 COLOR (SCHEME(9,10))
@         0,WCOLS()-1 FILL TO WROWS()-1,WCOLS()-1 COLOR (SCHEME(9,10))
@ WROWS()-1,        0 FILL TO WROWS()-1,WCOLS()-1 COLOR (SCHEME(9,10))
@         0,        0 FILL TO WROWS()-1,        0 COLOR (SCHEME(9,10))

IF !EMPTY(Win_Titl)
  @ 0,  INT((WCOLS()-2-LEN(Win_Titl))/2) SAY Win_Titl COLOR (SCHEME(9,10))
ENDIF

* Display "Close" icon on the top left corner
@ 0,0 SAY "" COLOR (SCHEME(9,10))

* Draw array limits in the window
@ 2,1 TO 2,WCOLS()-2
@ 1,lnLeftT+2 SAY ""
@ 2,lnLeftT+2 SAY ""
IF lnVCnt=1
	@ 3,lnLeftT+2 SAY ""
ELSE
	@ 3,lnLeftT+2 TO WROWS()-2,lnLeftT+2
ENDIF
@ 1,1 SAY "Line"

* Display data
=redraw("HV")
=drawCursor()


* Main edition loop

DO WHILE ! llExit
  
  lnKey=INKEY("M")
                                           
  DO CASE                                  
	CASE LineFlg						   && Force full line
	  DO CASE
		CASE LASTKEY()=19 OR LASTKEY()=127 OR ;
			LASTKEY()=5	   				   && Skip Back?
		  = ScanBack()					   && Find previous edit field
          = editCell()                     && Edit it
		CASE lnCol = lnHCnt				   && End of line?
		  Ctrl_NewLne = .F.				   && Not a newline any more
		  =screenleft()					   && Reset to start of line
		  =movedown()					   && Down to next line
	      LineFlg = .F.
		OTHERWISE						   && Move on
		  = ScanFwrd()					   && Find next edit field
          = editCell()                     && Edit it
	  ENDCASE
    CASE lnKey=0                           && No key pressed
      LOOP                                 
    CASE lnKey=151                         && Left mouse button
      =mousePress()                        
    CASE lnKey=4                           && Right
      =moveRight()                         
    CASE lnKey=19 OR lnKey=127             && Left
      =moveLeft()                          
    CASE lnKey=24                          && Down
      =moveDown()                          
    CASE lnKey=5                           && Up
      =moveUp()                            
    CASE lnKey=1                           && Home
	  =BlnkLne_Chk()					   && Check for current Blank Line
      =screenHome()                        
    CASE lnKey=6                           && End
	  =BlnkLne_Chk()					   && Check for current Blank Line
      =screenEnd()                         
    CASE lnKey=9                           && Tab
	  =BlnkLne_Chk()					   && Check for current Blank Line
      =screenRight()                       
    CASE lnKey=15                          && BackTab
	  =BlnkLne_Chk()					   && Check for current Blank Line
      =screenLeft()                        
    CASE lnKey=18                          && Page up
	  =BlnkLne_Chk()					   && Check for current Blank Line
      =screenUp()                          
    CASE lnKey=3                           && Page down
	  =BlnkLne_Chk()					   && Check for current Blank Line
      =screenDown()                        
    CASE lnKey=13                          && Enter
      =editCell()                          
    CASE lnKey=10                          && Ctrl-Enter
      =exitAedit()                           
	CASE lnKey=133						   && F11 - Delete line
	  IF !Ctrl_Enq .AND. !Updte			   && If not Enquiry mode
		=Rem_Row()
	  ENDIF
	CASE lnKey=134 .AND. !Updte			   && F12 - Insert line
	  IF !Ctrl_Enq						   && If not Enquiry mode
		=Ins_Row()
	  ENDIF
    CASE lnKey=27                          && Escape
	  =BlnkLne_Chk()					   && Check for current Blank Line
      =exitAedit()
	CASE BETWEEN(lnKey,-9,-1)			   && F2-F10 Keys
	  Work = Fkeys_Actions[ABS(lnKey)+1]
	  IF !EMPTY(Work)
		Arr_Row = lnTopRow + lnRow - 1				&& Absolute Row
		IF LEFT(ALLTRIM(UPPER(Work)),3)="DO "
			&Work
		ELSE
			=EVALUATE(Work)
		ENDIF
	  ENDIF
    CASE (BETWEEN(lnKey,48,57) OR lnKey=45 OR BETWEEN(lnKey,65,122));
      .AND. !Ctrl_Enq			   && "-" or digit or letter
      KEYBOARD CHR(lnKey)                  
      =editCell()                          
  ENDCASE
ENDDO

* Clean up after ourselves...
RELEASE WINDOW editArray
RELEASE WINDOW wVElev
RELEASE WINDOW wHElev

POP KEY

SET BORDER TO &lcBorder
SET COMPATIBLE &lcCompStat
SET ESCAPE &lcEscStat
SET CURSOR &lcCurStat
SET TALK &lcTalkStat

* Return whether the array was "Changed" or "Unchanged" (lcResult
* was checked in ExitAedit() )

RETURN lcResult

*!*********************************************************************
*!
*!       Function: REDRAW()
*!
*!      Called by: AEDIT.PRG                         
*!               : MOUSEPRESS()       (function  in AEDIT.PRG)
*!               : MOVERIGHT()        (function  in AEDIT.PRG)
*!               : MOVELEFT()         (function  in AEDIT.PRG)
*!               : MOVEDOWN()         (function  in AEDIT.PRG)
*!               : MOVEUP()           (function  in AEDIT.PRG)
*!               : SCREENHOME()       (function  in AEDIT.PRG)
*!               : SCREENEND()        (function  in AEDIT.PRG)
*!               : SCREENRIGHT()      (function  in AEDIT.PRG)
*!               : SCREENLEFT()       (function  in AEDIT.PRG)
*!               : SCREENUP()         (function  in AEDIT.PRG)
*!               : SCREENDOWN()       (function  in AEDIT.PRG)
*!
*!*********************************************************************

FUNCTION redraw

* PURPOSE
* -------
* Display a screenful of data
*
* PARAMETERS
* ----------
* lcTitles : If this parameter contains "V" the row titles are 
*            redrawn along with the rest of the array.
*            If this parameter contains "H" the column titles are 
*            redrawn along with the rest of the array.

PARAMETERS lcTitles

IF 'H' $ UPPER(lcTitles)
  FOR j=1 TO lnHCnt
    @ 1,lnLeftT+3+IIF(j>1,lnRowAcum[j-1],0) SAY;
      IIF("9"$CtrlArr[Ctrl_Pcts,j],PADL(CtrlArr[Ctrl_Hdrs,j],lnRowSzs[j]), ;
      PADR(CtrlArr[Ctrl_Hdrs,j],lnRowSzs[j]) ) ;
      COLOR (SCHEME(9,2))
  ENDFOR
ENDIF

IF 'V' $ UPPER(lcTitles)
  j = MIN(lnVCnt, ALEN(laArr,1))
  FOR i=1 TO j
    @ i+2,2 SAY PADR(laLeftT[i+lnTopRow-1],lnLeftT) ;
   	  COLOR (SCHEME(9,2))
  ENDFOR
  IF j < lnVCnt
	FOR i = j+1 TO lnVCnt
	  @ i+2,2 SAY SPACE(LEN(laLeftT[1])) COLOR (SCHEME(9,2))
	ENDFOR
  ENDIF
ENDIF

FOR i=1 TO MIN(lnVCnt, ALEN(laArr,1))
  FOR j=1 TO lnHCnt
    @ i+2,lnLeftT+3+IIF(j>1,lnRowAcum[j-1],0);
      SAY laArr[lnTopRow+i-1,j] ;
      PICTURE CtrlArr[Ctrl_Pcts,j] COLOR (SCHEME(9,2))
  ENDFOR
ENDFOR
IF i<=lnVCnt
	@ i+2, lnLeftT+3 SAY SPACE(lnRowLen-4)
ENDIF
RETURN .T.

*!*********************************************************************
*!
*!       Function: DRAWCURSOR()
*!
*!      Called by: AEDIT.PRG                         
*!               : MOUSEPRESS()       (function  in AEDIT.PRG)
*!               : MOVERIGHT()        (function  in AEDIT.PRG)
*!               : MOVELEFT()         (function  in AEDIT.PRG)
*!               : MOVEDOWN()         (function  in AEDIT.PRG)
*!               : MOVEUP()           (function  in AEDIT.PRG)
*!               : SCREENHOME()       (function  in AEDIT.PRG)
*!               : SCREENEND()        (function  in AEDIT.PRG)
*!               : SCREENRIGHT()      (function  in AEDIT.PRG)
*!               : SCREENLEFT()       (function  in AEDIT.PRG)
*!               : SCREENUP()         (function  in AEDIT.PRG)
*!               : SCREENDOWN()       (function  in AEDIT.PRG)
*!               : EDITCELL()         (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION drawCursor

* PURPOSE
* -------
* Display the cursor (a whole cell)
*

* Column title

@ 1,lnLeftT+3+IIF(lnCol>1,lnRowAcum[lnCol-1],0) FILL TO ;
  1,lnLeftT+lnRowAcum[lnCol]+2 COLOR (SCHEME(9,7))

* Row title
@ lnRow+2,2 FILL TO lnRow+2,1+lnLeftT COLOR (SCHEME(9,7))

* Cursor itself
IF !(LineFlg .AND. lnCol > 1)
	@ lnRow+2,lnLeftT+3+IIF(lnCol>1,lnRowAcum[lnCol-1],0) FILL TO ;
	  lnRow+2,lnLeftT+lnRowAcum[lnCol]+1 COLOR (SCHEME(9,7))
ENDIF

RETURN .T.

*!*********************************************************************
*!
*!       Function: CLEARCURSOR()
*!
*!      Called by: MOUSEPRESS()       (function  in AEDIT.PRG)
*!               : MOVERIGHT()        (function  in AEDIT.PRG)
*!               : MOVELEFT()         (function  in AEDIT.PRG)
*!               : MOVEDOWN()         (function  in AEDIT.PRG)
*!               : MOVEUP()           (function  in AEDIT.PRG)
*!               : SCREENHOME()       (function  in AEDIT.PRG)
*!               : SCREENEND()        (function  in AEDIT.PRG)
*!               : SCREENRIGHT()      (function  in AEDIT.PRG)
*!               : SCREENLEFT()       (function  in AEDIT.PRG)
*!               : SCREENUP()         (function  in AEDIT.PRG)
*!               : SCREENDOWN()       (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION clearCursor

* PURPOSE
* -------
* Clear the cursor
*

* Column title
@ 1,lnLeftT+3+IIF(lnCol>1,lnRowAcum[lnCol-1],0) FILL TO ;
  1,lnLeftT+lnRowAcum[lnCol]+2 COLOR (SCHEME(9,2))

* Row title
@ lnRow+2,2 FILL TO lnRow+2,1+lnLeftT COLOR (SCHEME(9,2))

* Cursor itself
@ lnRow+2,lnLeftT+3+IIF(lnCol>1,lnRowAcum[lnCol-1],0) FILL TO ;
  lnRow+2,lnLeftT+lnRowAcum[lnCol]+1 COLOR (SCHEME(9,2))

RETURN .T.

*!*********************************************************************
*!
*!       Function: DRAWELEV()
*!
*!      Called by: MOUSEPRESS()       (function  in AEDIT.PRG)
*!               : MOVERIGHT()        (function  in AEDIT.PRG)
*!               : MOVELEFT()         (function  in AEDIT.PRG)
*!               : MOVEDOWN()         (function  in AEDIT.PRG)
*!               : MOVEUP()           (function  in AEDIT.PRG)
*!               : SCREENHOME()       (function  in AEDIT.PRG)
*!               : SCREENEND()        (function  in AEDIT.PRG)
*!               : SCREENRIGHT()      (function  in AEDIT.PRG)
*!               : SCREENLEFT()       (function  in AEDIT.PRG)
*!               : SCREENUP()         (function  in AEDIT.PRG)
*!               : SCREENDOWN()       (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION drawElev

* PURPOSE
* -------
* Display the elevators
*
* PARAMETERS
* ----------
* lcHV     : If this parameter contains "V" the vertical elevator
*            is redrawn.

PARAMETERS lcHV

IF 'V' $ UPPER(lcHV)
  IF lnVCnt<ALEN(laArr,1)
    lnVElev=FLOOR((WROWS()-5)*(lnTopRow+lnRow-2)/(ALEN(laArr,1)-1))
    MOVE WINDOW wVElev TO 2+lnVElev,WCOLS()-1
  ENDIF
ENDIF

RETURN .T.

*!*********************************************************************
*!
*!       Function: EDITCELL()
*!
*!      Called by: AEDIT.PRG                         
*!
*!          Calls: DRAWCURSOR()       (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION editCell

* PURPOSE
* -------
* GET the current cell
*

Arr_Row = lnTopRow + lnRow - 1				&& Absolute Row

IF Ctrl_Enq
	RETURN .T.
ENDIF

IF lnCol = 1
	LineFlg = .T.
ENDIF

Cell = laArr[lnRow+lnTopRow-1,lnCol+lnLeftCol-1]

IF !EMPTY(CtrlArr[Ctrl_Dflt, lnCol]) .AND. EMPTY(Cell)	&& Default
	IF Col_Typs[lnCol] = "N" .OR. Col_Typs[lnCol]="D"
		Cell = EVALUATE(CtrlArr[Ctrl_Dflt, lnCol])
	ELSE
		Cell = PADR(EVALUATE(CtrlArr[Ctrl_Dflt, lnCol]), LEN(Cell))
	ENDIF
	laArr[lnRow+lnTopRow-1,lnCol+lnLeftCol-1] = Cell && Save new Value
	= Arr_Disp(lnCol)						&& Redisplay Value
ENDIF

IF EVALUATE(CtrlArr[Ctrl_Whnc, lnCol])			&& Evaluate WHEN clause

	IF !EMPTY(CtrlArr[Ctrl_Pmpt, lnCol])
		@ WROWS()-1, 4 SAY PADC(CtrlArr[Ctrl_Pmpt, lnCol],WCOLS()-5) ;
		  COLOR (SCHEME(9,10))
	  ENDIF
	  SET CURSOR ON
	  POP KEY
	  @ lnRow+2,lnLeftT+3+IIF(lnCol>1,lnRowAcum[lnCol-1],0) ;
	    GET Cell PICTURE CtrlArr[Ctrl_Pcts,lnCol] ;
	    VALID EVALUATE(CtrlArr[Ctrl_Vald, lnCol])
	  READ
	  SET CURSOR OFF
	  PUSH KEY CLEAR
      IF LASTKEY() = 27							&& Escape
	      IF lnTopRow+lnRow-1 = ALEN(laArr,1) .AND. LineFlg .AND. Ctrl_NewLne
		    LineFlg = .F.
			Ctrl_NewLne = .F.
			=BlankLine(lnTopRow+lnRow-1, @laArr)
			=ReDraw("V")
			lnCol = 1
		    =BlnkLne_Chk()					    && Check for current Blank Line
		  ELSE
	    	IF LineFlg
		      LineFlg = .F.						&& Exits to control mode
		    ENDIF
		  ENDIF	  
      ELSE
	 	  laArr[lnRow+lnTopRow-1,lnCol+lnLeftCol-1] = Cell && Save new Value
	  ENDIF
ENDIF

IF !EMPTY(CtrlArr[Ctrl_Pmpt, lnCol])
	@ WROWS()-1, 0 SAY SPACE(WCOLS()) COLOR (SCHEME (9,10))
ENDIF

=drawCursor()

RETURN .T.

*!*********************************************************************
*!
*!       Function: MOVELEFT()
*!
*!      Called by: AEDIT.PRG                         
*!               : MOUSEPRESS()       (function  in AEDIT.PRG)
*!
*!          Calls: REDRAW()           (function  in AEDIT.PRG)
*!               : CLEARCURSOR()      (function  in AEDIT.PRG)
*!               : DRAWCURSOR()       (function  in AEDIT.PRG)
*!               : DRAWELEV()         (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION moveLeft

* PURPOSE
* -------
* Move the cursor one cell left
*

IF lnCol=1
  IF (lnLeftCol>1)
    lnLeftCol=lnLeftCol-1
    =redraw("H")
  ENDIF
ELSE
  =ClearCursor()
  lnCol=lnCol-1
ENDIF

=drawCursor()

RETURN .T.

*!*********************************************************************
*!
*!       Function: MOVERIGHT()
*!
*!      Called by: AEDIT.PRG                         
*!               : MOUSEPRESS()       (function  in AEDIT.PRG)
*!
*!          Calls: REDRAW()           (function  in AEDIT.PRG)
*!               : CLEARCURSOR()      (function  in AEDIT.PRG)
*!               : DRAWCURSOR()       (function  in AEDIT.PRG)
*!               : DRAWELEV()         (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION moveRight

* PURPOSE
* -------
* Move the cursor one cell right
*

IF (lnCol<>lnHCnt .AND. ValidLine(lnTopRow+lnRow-1)) .OR. LineFlg
  =ClearCursor()
  lnCol=lnCol+1
ENDIF

=drawCursor()

RETURN .T.

*!*********************************************************************
*!
*!       Function: MOVEUP()
*!
*!      Called by: AEDIT.PRG                         
*!               : MOUSEPRESS()       (function  in AEDIT.PRG)
*!
*!          Calls: REDRAW()           (function  in AEDIT.PRG)
*!               : CLEARCURSOR()      (function  in AEDIT.PRG)
*!               : DRAWCURSOR()       (function  in AEDIT.PRG)
*!               : DRAWELEV()         (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION moveUp

* PURPOSE
* -------
* Move the cursor one cell up
*
Arr_Row = lnTopRow+lnRow-1
Work = ALEN(laArr,1)

IF lnRow=1
  IF lnTopRow>1
    lnTopRow=lnTopRow-1
    =redraw("V")
  ENDIF
ELSE
  =ClearCursor()
  IF EMPTY(laArr[ Arr_Row, 1] )
	IF !EMPTY(CtrlArr[Ctrl_Prdl,1])			&& Pre-Delete Row
	  Do_Flg=EVALUATE(CtrlArr[Ctrl_Prdl,1])
	ENDIF
	IF Do_Flg
	  = BlnkLne_Chk()
	  = redraw("V")
	ELSE
      lnRow=lnRow-1
	ENDIF
  ELSE
    lnRow=lnRow-1
  ENDIF 
ENDIF

=drawCursor()
=drawElev("V")

RETURN .T.

*!*********************************************************************
*!
*!       Function: MOVEDOWN()
*!
*!      Called by: AEDIT.PRG                         
*!               : MOUSEPRESS()       (function  in AEDIT.PRG)
*!
*!          Calls: REDRAW()           (function  in AEDIT.PRG)
*!               : CLEARCURSOR()      (function  in AEDIT.PRG)
*!               : DRAWCURSOR()       (function  in AEDIT.PRG)
*!               : DRAWELEV()         (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION moveDown

* PURPOSE
* -------
* Move the cursor one cell down
*
Work = ALEN(laArr,1)

IF lnRow>=MIN(lnVCnt, Work)
  IF (lnTopRow+lnVCnt-1 < Work)
      lnTopRow=lnTopRow+1
      =redraw("V")
  ELSE
	IF !EMPTY(CtrlArr[Ctrl_Prin,1])			&& Pre-Insert Row
	  Do_Flg=EVALUATE(CtrlArr[Ctrl_Prin,1])
	ENDIF
  	IF (lnTopRow+lnRow-1 = Work) .AND. ValidLine(lnTopRow+lnRow-1) ;
  	  .AND. lnCol = 1 .AND. !Ctrl_Enq .AND. Do_Flg .AND. !Updte
	  = ClearCursor()
	  DIMENSION laArr[lnTopRow+lnRow,ALEN(laArr,2)]
	  DIMENSION laBackup[lnTopRow+lnRow,ALEN(laArr,2)]
	  = BlankLine(lnTopRow+lnRow, @laArr)
	  = BlankLine(lnTopRow+lnRow, @laBackup)
	  DIMENSION laLeftT[lnTopRow+lnRow,1]
	  = RowNos()
	  IF ALEN(laArr,1)>lnVCnt
	   	lnTopRow=lnTopRow+1
	  ELSE
	  	lnRow = lnRow + 1
	  ENDIF
	  Ctrl_NewLne = .T.
	  = redraw('HV')
	  IF lnVCnt < ALEN(laArr,1) .AND. !WEXIST("wVElev")
	  	= Cre_Velv()
	  ENDIF
	ENDIF
  ENDIF
ELSE
  IF !EMPTY(laArr[lnTopRow+lnRow-1,lnCol]) .OR. (lnCol=1 .AND. ValidLine(lnTopRow+lnRow-1))
    =ClearCursor()
    lnRow=lnRow+1
  ENDIF
ENDIF

=drawCursor()
=drawElev("V")

RETURN .T.

*!*********************************************************************
*!
*!       Function: SCREENHOME()
*!
*!      Called by: AEDIT.PRG                         
*!
*!          Calls: CLEARCURSOR()      (function  in AEDIT.PRG)
*!               : REDRAW()           (function  in AEDIT.PRG)
*!               : DRAWCURSOR()       (function  in AEDIT.PRG)
*!               : DRAWELEV()         (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION screenHome

* PURPOSE
* -------
* Move the cursor to the first cell of the first line
*

PRIVATE lcTemp

lcTemp=""
*IF lnLeftCol>1
*  lcTemp="H"
*ENDIF
IF lnTopRow>1
  lcTemp=lcTemp+"V"
ENDIF

=ClearCursor()
lnTopRow=1
lnLeftCol=1
lnRow=1
lnCol=1

IF ! EMPTY(lcTemp)
  =redraw(lcTemp)
ENDIF

=drawCursor()
=drawElev(lcTemp)

RETURN .T.

*!*********************************************************************
*!
*!       Function: SCREENEND()
*!
*!      Called by: AEDIT.PRG                         
*!
*!          Calls: CLEARCURSOR()      (function  in AEDIT.PRG)
*!               : REDRAW()           (function  in AEDIT.PRG)
*!               : DRAWCURSOR()       (function  in AEDIT.PRG)
*!               : DRAWELEV()         (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION screenEnd

* PURPOSE
* -------
* Move the cursor to the last cell of the last line
*

PRIVATE lcTemp

lctemp=""
IF lnTopRow<ALEN(laArr,1)-lnVCnt+1
  lcTemp=lcTemp+"V"
ENDIF

=ClearCursor()
lnTopRow=ALEN(laArr,1)-MIN(lnVCnt,ALEN(laArr,1))+1
lnLeftCol=1
lnRow=MIN(lnVCnt,ALEN(laArr,1))
lnCol=lnHCnt

IF ! EMPTY(lcTemp)
  =redraw(lcTemp)
ENDIF

=drawCursor()
=drawElev(lcTemp)

RETURN .T.

*!*********************************************************************
*!
*!       Function: SCREENLEFT()
*!
*!      Called by: AEDIT.PRG                         
*!               : MOUSEPRESS()       (function  in AEDIT.PRG)
*!
*!          Calls: CLEARCURSOR()      (function  in AEDIT.PRG)
*!               : REDRAW()           (function  in AEDIT.PRG)
*!               : DRAWCURSOR()       (function  in AEDIT.PRG)
*!               : DRAWELEV()         (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION screenLeft

* PURPOSE
* -------
* Move the cursor one screen left
*

IF lnCol>1
  =clearCursor()
  lnCol=1
ELSE
  lnLeftCol=MAX(1,lnLeftCol-lnHCnt+1)
  =redraw("H")
ENDIF

=drawCursor()
*=drawElev("H")

RETURN .T.

*!*********************************************************************
*!
*!       Function: SCREENRIGHT()
*!
*!      Called by: AEDIT.PRG                         
*!               : MOUSEPRESS()       (function  in AEDIT.PRG)
*!
*!          Calls: CLEARCURSOR()      (function  in AEDIT.PRG)
*!               : REDRAW()           (function  in AEDIT.PRG)
*!               : DRAWCURSOR()       (function  in AEDIT.PRG)
*!               : DRAWELEV()         (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION screenRight

* PURPOSE
* -------
* Move the cursor one screen right
*

IF lnCol<lnHCnt
  =clearCursor()
  lnCol=lnHCnt
ELSE
  lnLeftCol=MIN(ALEN(laArr,2)-lnHCnt+1,lnLeftCol+lnHCnt-1)
  =redraw("H")
ENDIF

=drawCursor()

RETURN .T.

*!*********************************************************************
*!
*!       Function: SCREENUP()
*!
*!      Called by: AEDIT.PRG                         
*!               : MOUSEPRESS()       (function  in AEDIT.PRG)
*!
*!          Calls: CLEARCURSOR()      (function  in AEDIT.PRG)
*!               : REDRAW()           (function  in AEDIT.PRG)
*!               : DRAWCURSOR()       (function  in AEDIT.PRG)
*!               : DRAWELEV()         (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION screenUp

* PURPOSE
* -------
* Move the cursor one screen up
*

IF lnRow>1
  =clearCursor()
  lnRow=1
ELSE
  lnTopRow=MAX(1,lnTopRow-lnVCnt+1)
  =redraw("V")
ENDIF

=drawCursor()
=drawElev("V")

RETURN .T.

*!*********************************************************************
*!
*!       Function: SCREENDOWN()
*!
*!      Called by: AEDIT.PRG                         
*!               : MOUSEPRESS()       (function  in AEDIT.PRG)
*!
*!          Calls: CLEARCURSOR()      (function  in AEDIT.PRG)
*!               : REDRAW()           (function  in AEDIT.PRG)
*!               : DRAWCURSOR()       (function  in AEDIT.PRG)
*!               : DRAWELEV()         (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION screenDown

* PURPOSE
* -------
* Move the cursor one screen down
*

IF lnRow<lnVCnt
  =clearCursor()
  lnRow=MIN(lnVCnt,ALEN(laArr,1))
ELSE
  lnTopRow=MIN(ALEN(laArr,1)-lnVCnt+1,lnTopRow+lnVCnt-1)
  =redraw("V")
ENDIF

=drawCursor()
=drawElev("V")

RETURN .T.

*!*********************************************************************
*!
*!       Function: MOUSEPRESS()
*!
*!      Called by: AEDIT.PRG                         
*!
*!          Calls: CLEARCURSOR()      (function  in AEDIT.PRG)
*!               : REDRAW()           (function  in AEDIT.PRG)
*!               : DRAWCURSOR()       (function  in AEDIT.PRG)
*!               : DRAWELEV()         (function  in AEDIT.PRG)
*!               : MOVELEFT()         (function  in AEDIT.PRG)
*!               : MOVERIGHT()        (function  in AEDIT.PRG)
*!               : SCREENLEFT()       (function  in AEDIT.PRG)
*!               : SCREENRIGHT()      (function  in AEDIT.PRG)
*!               : MOVEUP()           (function  in AEDIT.PRG)
*!               : MOVEDOWN()         (function  in AEDIT.PRG)
*!               : SCREENUP()         (function  in AEDIT.PRG)
*!               : SCREENDOWN()       (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION mousePress

* PURPOSE
* -------
* Handle mouse clicks and drag events
*

PRIVATE lnMRow     && Row position of mouse-click
PRIVATE lnMCol     && Col position of mouse-click
PRIVATE lnNewRow   && New array index of the cursor row 
                   && after a mouse drag.
PRIVATE lnNewCol   && New array index of the cursor column
                   && after a mouse drag.

* Store mouse position
lnMRow=MROW()
lnMCol=MCOL()

* Click on row 0, col 0: Close window
IF (lnMRow=0) .AND. (lnMCol=0)
  =exitAedit()
  RETURN .T.
ENDIF

* Click on another position of row 0: Drag window
IF (lnMRow=0) .AND. BETWEEN(lnMCol,1,WCOLS()-2)
  DO WHILE MDOWN()
    MOVE WINDOW editArray TO MROW(''),MCOL('')-lnMCol
  ENDDO
  RETURN .T.
ENDIF


* Click somewhere on the vertical elevator
IF (lnMCol=WCOLS()-1) .AND. (lnVCnt<ALEN(laArr,1))
  DO CASE
		* Click on the vertical elevator: drag elevator
    CASE (lnMRow=lnVElev+2)
      * Lift elevator
      DO WHILE MDOWN()
        MOVE WINDOW wVElev TO MIN(WROWS()-3,MAX(MROW(),2)),WCOLS()-1
      ENDDO
      * Compute the new array row index for the cursor
      lnNewRow=FLOOR(1+(ALEN(laArr,1)-1)*MIN(WROWS()-5,MAX(MROW()-2,0))/(WROWS()-5))
      =ClearCursor()
      * Adjust display and cursor position 
      IF BETWEEN(lnNewRow,lnTopRow,lnTopRow+lnVCnt-1)
        lnRow=lnNewRow-lnTopRow+1
      ELSE
        IF lnNewRow>ALEN(laArr,1)-lnVCnt+1
          lnTopRow=ALEN(laArr,1)-lnVCnt+1
          lnRow=lnNewRow-lnTopRow+1
        ELSE
          lnTopRow=lnNewRow
          lnRow=1
        ENDIF
        =redraw("V")
      ENDIF
      =drawCursor()
      =drawElev("V")
    * Click on top elevator arrow: Move one cell up
    CASE lnMRow=1
      DO WHILE MDOWN()
        =moveUp()
        =INKEY(.2)
      ENDDO
    * Click on bottom elevator arrow: Move one cell down
    CASE lnMRow=WROWS()-2
	  DO WHILE MDOWN()
	    =moveDown()
		=INKEY(.2)
	  ENDDO
    * Click between the top elevator arrow and
    * the elevator itself: Move one screen up
    CASE BETWEEN(lnMRow,2,lnVElev+1)
	  DO WHILE MDOWN()
	    =screenUp()
	    =INKEY(.4)
	  ENDDO
    * Click between the bottom elevator arrow and
    * the elevator itself: Move one screen down
    CASE BETWEEN(lnMRow,3+lnVElev,WROWS()-3)
	  DO WHILE MDOWN()
        =screenDown()
	    =INKEY(.4)
	  ENDDO
  ENDCASE
  RETURN .T.
ENDIF

* Click on a cell: Edit it
IF BETWEEN(lnMRow,3,WROWS()-2)
  IF BETWEEN(lnMCol,lnLeftT+3,WCOLS()-2)
    =clearCursor()
	lnCol = 1
    lnRow=lnMrow-2
	IF !(EMPTY(laArr[lnRow, 1]) .OR. !ValidLine(lnRow))
		FOR i=2 TO ALEN(lnRowAcum,1)
		  IF BETWEEN(lnMCol-lnLeftT-2, lnRowAcum[i-1], lnRowAcum[i])
			lnCol = i
		  ENDIF
		ENDFOR (i)
	ENDIF
    =drawElev("V")
    =drawCursor()
  ENDIF
ENDIF

RETURN .T.

*!*********************************************************************
*!
*!       Function: BLANKLINE()
*!
*!      Called by: AEDIT.PRG                         
*!
*!*********************************************************************
FUNCTION BlankLine
PARAMETER i, Arrn

* PURPOSE
* -------
* Fill a new row with empty fields
*

FOR j=1 TO lnHCnt
   	Arrn[i, j] = Empty_Field(j, @laArr)	&& Force Empty
ENDFOR (j)

RETURN .T.

*!*********************************************************************
*!
*!       Function: VALIDLINE()
*!
*!      Called by: AEDIT.PRG                         
*!
*!*********************************************************************
FUNCTION ValidLine
PARAMETER i

* PURPOSE
* -------
* Determine if all of the fields on this row are empty
*

RetVal = .F.

FOR j=2 TO lnHCnt
	IF !EMPTY(laArr[i, j])
	  RetVal = .T.
	  EXIT
	ENDIF
ENDFOR (j)

RETURN RetVal

*!*********************************************************************
*!
*!       Function: REM_ROW()
*!
*!      Called by: AEDIT.PRG                         
*!
*!*********************************************************************
FUNCTION Rem_Row

* PURPOSE
* -------
* Deletes the current Row from the Array
*

Do_Flg = .T.

Arr_Row = lnTopRow + lnRow - 1					&& Absolute Row

IF lnRow <= ALEN(laArr,1)
  IF !EMPTY(CtrlArr[Ctrl_Prdl,1])					&& Pre-Delete Row
	Do_Flg=EVALUATE(CtrlArr[Ctrl_Prdl,1])
  ENDIF

  IF Do_Flg
	  IF ALEN(laArr,1) = 1						&& Deleting last line?
		=BlankLine(1, @laArr)					&& Just Blank it
 	  ELSE
		=DelRow(Arr_Row)						&& Delete Line
		IF lnTopRow > 1
		  lnTopRow = lnTopRow - 1
		ENDIF
		IF lnRow > 1 .AND. ALEN(laArr,1)<lnVCnt
		  lnRow = lnRow - 1
		ENDIF
	  ENDIF
	  IF lnVCnt >= ALEN(laArr,1) .AND. WEXIST("wVElev"))
		= Rem_Velv()							&& Remove Elevator
	  ENDIF
	  = Redraw("V")								&& Redraw Screen
	  = DrawCursor()
	  IF !EMPTY(CtrlArr[Ctrl_Psdl,1])			&& Post-Delete Row
		=EVALUATE(CtrlArr[Ctrl_Psdl,1])
	  ENDIF
  ENDIF
ENDIF
RETURN .T.
  
  
*!*********************************************************************
*!
*!       Function: INS_ROW()
*!
*!      Called by: AEDIT.PRG                         
*!
*!*********************************************************************
FUNCTION Ins_Row

* PURPOSE
* -------
* Inserts a new blank row at the current Row prsition
*

Arr_Row = lnTopRow + lnRow - 1				&& Absolute Row inserting into
Do_Flg = .T.

IF !EMPTY(laArr[Arr_row, 1])				&& Not 2 blank rows consecutively

  IF !EMPTY(CtrlArr[Ctrl_Prin,1])			&& Pre-Insert Row
	Do_Flg=EVALUATE(CtrlArr[Ctrl_Prin,1])
  ENDIF
  IF Do_Flg
	= InsRow(Arr_Row)						&& Insert Line
	= Redraw("V")							&& Redraw Screen
	= DrawCursor()
	IF lnVCnt < ALEN(laArr,1) .AND. !WEXIST("wVElev")
	  = Cre_Velv()							&& Create Vertical elevator
	ENDIF
	IF !EMPTY(CtrlArr[Ctrl_Psin,1])			&& Post-Insert Row
	  =EVALUATE(CtrlArr[Ctrl_Psin,1])
    ENDIF
  ENDIF


ENDIF

RETURN .T.

*!*********************************************************************
*!
*!       Function: DELROW()
*!
*!      Called by: AEDIT.PRG                         
*!
*!*********************************************************************
FUNCTION DelRow
PARAMETER i

* PURPOSE
* -------
* Delete a row and shrink the array
*

IF i = ALEN(laArr,1)					&& Inserting new Row at end
	= ADEL(laBackup, i)
	DIMENSION laBackup[ALEN(laBackup,1)-1,ALEN(laBackup,2)]
ENDIF

= ADEL(laArr, i)
DIMENSION laArr[ALEN(laArr,1)-1,ALEN(laArr,2)]
DIMENSION laLeftT[ALEN(laArr,1),1]
= RowNos()

RETURN .T.


*!*********************************************************************
*!
*!       Function: INSROW()
*!
*!      Called by: AEDIT.PRG                         
*!
*!*********************************************************************
FUNCTION InsRow
PARAMETER i

* PURPOSE
* -------
* Insert a new blank row and extend the array
*

RetVal = .T.

DIMENSION laArr[ALEN(laArr,1)+1,ALEN(laArr,2)]
DIMENSION laBackup[ALEN(laArr,1)+1,ALEN(laArr,2)]
DIMENSION laLeftT[ALEN(laArr,1),1]
= AINS(laArr, i)
= AINS(laBackup, i)
= BlankLine(i, @laArr)
= BlankLine(i, @laBackup)
= RowNos()
RETURN RetVal

*!*********************************************************************
*!
*!       Function: ROWNOS()
*!
*!      Called by: AEDIT.PRG                         
*!
*!*********************************************************************
FUNCTION RowNos

* PURPOSE
* -------
* Rebuild the array counters for the left column
*

* Line titles (1,2,3...)
FOR i=1 TO ALEN(laLeftT)
  laLeftT[i]=STR(i,3)
ENDFOR
RETURN


*!*********************************************************************
*!
*!       Function: SCANBACK()
*!
*!      Called by: AEDIT.PRG                         
*!
*!*********************************************************************
FUNCTION ScanBack

* PURPOSE
* -------
* Scan backwards along the row until we find an editable field (or
*	column number one)
*

IF lnCol > 1								&& If we're not at the start

  Arr_Row = lnTopRow + lnRow - 1			&& Absolute Row
  Arr_Ctrl = 1								&& Stepping backwards

  i = lnCol - 1
  =ClearCursor()

  FOR lnCol=i TO 1 STEP -1

	Cell = laArr[lnRow+lnTopRow-1,lnCol+lnLeftCol-1]

	IF !EMPTY(CtrlArr[Ctrl_Dflt, lnCol]) .AND. EMPTY(Cell)	&& Default
	  IF Col_Typs[lnCol] = "N" .OR. Col_Typs[lnCol]="D"
		Cell = EVALUATE(CtrlArr[Ctrl_Dflt, lnCol])
	  ELSE
		Cell = PADR(EVALUATE(CtrlArr[Ctrl_Dflt, lnCol]), LEN(Cell))
	  ENDIF
 	  laArr[lnRow+lnTopRow-1,lnCol+lnLeftCol-1] = Cell && Save new Value
	  = Arr_Disp(lnCol)
	ENDIF

	IF EVALUATE(CtrlArr[Ctrl_Whnc, lnCol])		&& When Evaluation
	  EXIT									&& Exit Loop
	ENDIF
	
  ENDFOR (lnCol)

  IF lnCol < 1
  	lnCol = 1
  ENDIF

  =drawCursor()
  Arr_Ctrl = 0								&& Normal

ENDIF
RETURN .T.
  
*!*********************************************************************
*!
*!       Function: SCANFWRD()
*!
*!      Called by: AEDIT.PRG                         
*!
*!*********************************************************************
FUNCTION ScanFwrd

* PURPOSE
* -------
* Scan forwards along the row until we find an editable field (or
*	the last column)
*
IF lnCol <= lnHCnt							&& If we're not at the end

  Arr_Row = lnTopRow + lnRow - 1			&& Absolute Row
  Arr_Ctrl = 0								&& Stepping forwards

  i = lnCol + 1
  =ClearCursor()

  FOR lnCol=i TO lnHCnt

	Cell = laArr[lnRow+lnTopRow-1,lnCol+lnLeftCol-1]

	IF !EMPTY(CtrlArr[Ctrl_Dflt, lnCol]) .AND. EMPTY(Cell)	&& Default
	  IF Col_Typs[lnCol] = "N" .OR. Col_Typs[lnCol]="D"
		Cell = EVALUATE(CtrlArr[Ctrl_Dflt, lnCol])
	  ELSE
		Cell = PADR(EVALUATE(CtrlArr[Ctrl_Dflt, lnCol]), LEN(Cell))
	  ENDIF
 	  laArr[lnRow+lnTopRow-1,lnCol+lnLeftCol-1] = Cell && Save new Value
	  = Arr_Disp(lnCol)
	ENDIF

	IF EVALUATE(CtrlArr[Ctrl_Whnc, lnCol])		&& When Evaluation
	  EXIT									&& Exit Loop
	ENDIF
	
  ENDFOR (lnCol)

  IF lnCol > lnHCnt
  	lnCol = lnHCnt
  ENDIF

  =drawCursor()
  Arr_Ctrl = 0								&& Normal

ENDIF

RETURN .T.

*!*********************************************************************
*!
*!       Function: EMPTY_FIELD()
*!
*!      Called by: AEDIT.PRG                         
*!
*!*********************************************************************
FUNCTION Empty_Field
PARAMETER i, Arrn

* PURPOSE
* -------
* Determine variable type and set to equivalent of empty
*

Work = Col_Typs[i]				&& Type deduced at start

DO CASE
  CASE Work = "C"				&& Character
	RetVal = SPACE(LEN(TRANSFORM(1, CtrlArr[Ctrl_Pcts,i])))
  CASE Work = "L"				&& Logical
	RetVal = .F.
  CASE Work = "N"				&& Numeric & Float
  	RetVal = 0
  CASE Work = "D"				&& Date
  	RetVal = {}
  OTHERWISE
  	RetVal = ""
ENDCASE

RETURN RetVal
  
*!*********************************************************************
*!
*!       Function: ARR_DISP()
*!
*!      Called by: AEDIT.PRG                         
*!
*!*********************************************************************
FUNCTION Arr_Disp
PARAMETER j

* PURPOSE
* -------
* Displays a single field
*

@ lnRow+2,lnLeftT+3+IIF(j>1,lnRowAcum[j-1],0);
   SAY laArr[lnTopRow+lnRow-1,j] ;
   PICTURE CtrlArr[Ctrl_Pcts,j] COLOR (SCHEME(9,2))

RETURN .T.

*!*********************************************************************
*!
*!       Function: CRE_VELV()
*!
*!      Called by: AEDIT.PRG                         
*!
*!*********************************************************************
FUNCTION Cre_Velv

* PURPOSE
* -------
* Create the Vertical elevator
*
* If vertical scrolling is needed, create and
* display vertical elevator
@         1,WCOLS()-1 SAY "" COLOR (SCHEME(9,10))
@ WROWS()-2,WCOLS()-1 SAY "" COLOR (SCHEME(9,10))
DEFINE WINDOW wVElev ;
  IN editArray ;
  FROM 2,WCOLS()-1 TO 2,WCOLS()-1 ;
  NONE ;
  COLOR SCHEME 9
ACTIVATE WINDOW wVElev
@ 0,0 SAY "" COLOR (SCHEME(9,10))
ACTIVATE WINDOW editarray
RETURN .T.
 

*!*********************************************************************
*!
*!       Function: REM_VELV()
*!
*!      Called by: AEDIT.PRG                         
*!
*!*********************************************************************
FUNCTION Rem_Velv

* PURPOSE
* -------
* Remove the Vertical elevator
*
RELEASE WINDOW wVElev					&& Remove Vertical Elev
@ 1,WCOLS()-1 SAY " " COLOR (SCHEME(9,10))
@ WROWS()-2,WCOLS()-1 SAY " " COLOR (SCHEME(9,10))

RETURN .T.

*!*********************************************************************
*!
*!       Function: BLNKLNE_CHK()
*!
*!      Called by: AEDIT.PRG                         
*!
*!*********************************************************************
FUNCTION BlnkLne_Chk

* PURPOSE
* -------
* Remove a blank line at the current row if necessary
*
Arr_Row = lnTopRow+lnRow-1

IF (!ValidLine(Arr_Row) .OR. EMPTY(laArr[Arr_Row,1])) AND ;
  ALEN(laArr,1) > 1 .AND. !Updte  			   	&& Delete invalid line
	= clearCursor()
	= DelRow(Arr_Row)
	IF lnTopRow+lnRow-1 > ALEN(laArr,1) AND lnTopRow > 1
	  lnTopRow = lnTopRow - 1
	ELSE
	  lnRow = IIF( lnRow > 1, lnRow - 1, 1)
	ENDIF
	= ReDraw("HV")
	= DrawCursor()
	IF lnVCnt >= ALEN(laArr,1) .AND. WEXIST("wVElev")
	  = Rem_Velv()
	ENDIF
ENDIF

RETURN .T.
 
*!*********************************************************************
*!
*!       Function: EXITAEDIT()
*!
*!      Called by: AEDIT.PRG                         
*!               : MOUSEPRESS()       (function  in AEDIT.PRG)
*!
*!*********************************************************************
FUNCTION ExitAedit

PRIVATE lcAnswer

* Compare the array with the backup copy
IF ALEN(laArr,1)<>ALEN(laBackup,1)
  lcResult=.T.
ELSE
  FOR i=1 TO ALEN(laArr,0)
	IF laArr[i]<>laBackup[i]
	  lcResult=.T.
	  EXIT
	ENDIF
  ENDFOR
ENDIF

* If the array was modified, ask the user to confirm his changes
IF lcResult
	  lcAnswer="Cancel"
    DEFINE WINDOW wmAskUser IN SCREEN ;
    FROM INT((SROW()-7)/2),INT((SCOL()-55)/2) ;
    TO INT((SROW()-7)/2)+6,INT((SCOL()-55)/2)+54 ;
    FLOAT ;
    NOCLOSE ;
    PANEL ;
    COLOR SCHEME 5 ;
    SHADOW
  ACTIVATE WINDOW wmAskUser
	  @ 1,2 SAY "Do you want to save your changes before exiting?"
  	@ 3,2 GET lcAnswer ;
    	PICTURE "@*HT \!\<Yes;\<No;\?\<Cancel" ;
    	SIZE 1,7,5
  	READ CYCLE MODAL
  RELEASE WINDOW wmAskUser
  ACTIVATE WINDOW editArray SAME
  DO CASE
  	CASE lcAnswer="Cancel"
  		* Nothing...
  	CASE lcAnswer="Yes"
  	  llExit=.T.
  	CASE lcAnswer="No"
	  IF ALEN(laArr,1) <> ALEN(laBackup,1)
		DIMENSION laArr[ALEN(laBackup,1),ALEN(laArr,2)]
	  ENDIF
  	  =ACOPY(laBackup,laArr)
	  lcResult=.F.
	  llExit=.T.
  ENDCASE
ELSE
	llExit=.T.
ENDIF

RETURN .T.

